/*===========================================
	JewelQuest v1.0 for wii by MCartman
===========================================*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
// time_t
#include <time.h>
// usleep
#include <ogcsys.h>
#include <gccore.h>
// eh eh pour dessiner en 2D ou 3D
#include "GRRLIB.h"

// pour lire sur la carte sd
#include "tff.h"

// pour charger un fichier png dans la memoire
#include "pngu.h"

// les accessoires
#include "../gfx/tete_dragon.h"
#include "../gfx/tete_dragon_ferme.h"
#include "../gfx/langue_debut.h"
#include "../gfx/langue_fin.h"
#include "../gfx/case_or.h"
#include "../gfx/case_rouge.h"
#include "../gfx/case_vert.h"
#include "../gfx/pret.h"
#include "../gfx/ok.h"
#include "../gfx/cest_fini.h"
#include "../gfx/termine.h"

// bonus
#include "../gfx/bonus/bonus.h"
#include "../gfx/bonus/zero.h"
#include "../gfx/bonus/un.h"
#include "../gfx/bonus/deux.h"
#include "../gfx/bonus/trois.h"
#include "../gfx/bonus/quatre.h"
#include "../gfx/bonus/cinq.h"
#include "../gfx/bonus/six.h"
#include "../gfx/bonus/sept.h"
#include "../gfx/bonus/huit.h"
#include "../gfx/bonus/neuf.h"

// les motifs
#include "../gfx/tete_b.h"
#include "../gfx/tete_m.h"
#include "../gfx/saphir.h"
#include "../gfx/emeraude.h"
#include "../gfx/piece.h"

// les motifs griss
#include "../gfx/tete_b_grise.h"
#include "../gfx/tete_m_grise.h"
#include "../gfx/saphir_grise.h"
#include "../gfx/emeraude_grise.h"
#include "../gfx/piece_grise.h"

// les polices de caractere
#include "../fonts/font5.h"

// le repertoire ou est install le jeu
#define repertoire_jeu "Homebrew/JQuest"

#define FALSE 0
#define TRUE 1

// les differents motifs
#define TETE_B 0
#define EMERAUDE 1
#define PIECE 2
#define SAPHIR 3
#define TETE_M 4

// la taille des motifs
#define MOTIF_WIDTH 30
#define MOTIF_HEIGHT 29

#define NBR_VIE 3

//#define DEBUG

// buffer affichage
extern u16 *GRRLIB_buffer;

// fond du plateau
void *fond_plateau = NULL;
int fond_plateau_width = 0;
int fond_plateau_height = 0;

// reload vers launcher (fonctionne pas !)
void (*reload)() = (void(*)())0x80001800;

// temps lors du lancement du plateau
time_t start_game;

// nombre de dossier nomm plateauX dans le repertoire repertoire_jeu
int nbr_plateau = 0;

// information sur le niveau
struct un_niveau
{
	// numero du niveau
	int num;

	// les positions
	int fond_x;
	int fond_y;
	int plateau_x;
	int plateau_y;
	int dragon_x;
	int dragon_y;
	int temps_x;
	int temps_y;
	int vie_x;
	int vie_y;
	int score_x;
	int score_y;
	
	// temps de jeu
	double temps;
	
	// motifs et cases
	int nbr_motif;
	int motif[5];
	int motif_aleatoire;
	int hors_limite;
	int case_vide;
	
	// plateau
	int nbr_lig;
	int nbr_col;
	
	// maximum 10 lignes et 10 colonnes
	int plateau[10][10];
	// les cases qui ont t checkes (lorsque l'utilisateur deplace un motif, les meme motifs qui sont a la suite sont alors checkes)
	int plateau_cases_check[10][10];
	// les cases valides (celle avec un fond jaune)
	int plateau_cases_validees[10][10];
	// les cases bloques (celle grises)
	int plateau_cases_bloquees[10][10];
	// la position de chaque motif sur le plateau (sert pour les animations)
	int position_x[10][10];
	int position_y[10][10];

}niveau;

// information sur le joueur
struct joueur
{
	int lig,col;	// ligne et colonne ou il se trouve
	char select;	// si la case est selectionne
	int score;		// son score
	char termine;	// a true si le temps est ecoul ou si toutes les cases ont t valides
	double temps;	// temps de jeu sur le niveau actuel
	int vie;		// nombre de vie du joueur
	char gagne;		// si le joueur a gagne
	char rejouer;	// si le joueur veut rejouer
	char pseudo[30]; // pseudo du joueur (pas encore utilis)
	
}gamer;

void debug(char* chaine);
int get_int_in_string(char* chaine);

void nbr_plateau_exist();
char charger_plateau(int n);
char charger_fond_plateau(int n);
void init_game();
void set_position_x_case(int lig, int col, int x);
int get_position_x_case(int lig, int col);
void set_position_y_case(int lig, int col, int y);
int get_position_y_case(int lig, int col);
char get_motif(int lig, int col);
void set_motif(int lig, int col, char motif);
int get_score(int lig, int col);
void inverse(int lig, int col, int lig1, int col1);
char is_vide(int lig, int col);
char is_checked(int lig, int col);
char is_valide(int lig, int col);
char is_bloque(int lig, int col);
void valide_case(int lig, int col);
void devalide_case(int lig, int col);
void check_case(int lig, int col);
void decheck_case(int lig, int col);
void check_case_lig(int lig_deb, int lig_fin, int col);
void check_case_col(int col_deb, int col_fin, int lig);
void bloque_case(int lig, int col);
void debloque_case(int lig, int col);
char check_plateau();
void valide_et_vide_case_check(char init);
void cascade_plateau();
void cascade_col(int la_col);
char is_all_valide();
void inverse_si_ok(int lig, int col, int lig1, int col1);
void dessine_fond();
void dessine_plateau(char img_case_check, char animation);
void dessine_temps();
void dessine_infos();
void dessine_pret();
void dessine_ok();
void dessine_termine();
void dessine_cest_fini();
void dessine_menu_fin();
void dessine_bonus(int score);
const u16* get_img_chiffre_bonus(char chiffre);
void animation_plateau();
void animation_inverse(int lig, int col, int lig1, int col1);
void animation_check_plateau(int temps_ms);
void animation_bonus();
void deplace_gamer();
char jouer_plateau();

void debug(char* chaine)
{
	#ifdef DEBUG
		GRRLIB_Print(45, 50, font5_char_width,font5_char_high,"                                                                  ",font5,0xffff,0x0000);
		GRRLIB_Print(45, 50, font5_char_width,font5_char_high,chaine,font5,0xffff,0x0000);
		GRRLIB_Render();
		VIDEO_WaitVSync();
		
		// on attend 1 sec avant de passer a autre chose
		//usleep(100000);
		do
		{
			PAD_ScanPads();
		}while(!(PAD_ButtonsDown (0) & PAD_BUTTON_A));
	#endif
}

// utiliser dans charger_plateau
// sert a recuperer les positions
int get_int_in_string(char* chaine)
{
	int retour = 0, i = 0;
	char integer[10];
	
	while((chaine[i] != '\n') && (chaine[i] != '\0') && (i < 9))
	{
		integer[i] = chaine[i];
		i++;
	}
	
	integer[i] = '\0';
	
	retour = atoi(integer);
	
	return retour;
}

// ouvre le fichier nbrniv.txt pour connaitre le nombre de niveau
void nbr_plateau_exist()
{
	char chemin[50];
	
	char erreur = FALSE;
	char fat_ok = FALSE;
	
	FIL fichier_nbr_plateau;
	FILINFO finfo;
	
	WORD bytes_read;
	u32 bytes_read_total;
	u8 *data = (u8 *)0x92000000;
	char* recherche;
	
	nbr_plateau = 0;
	
	sprintf(chemin, "%s/nbrniv.txt", repertoire_jeu);
	
	fat_ok = PNGU_Init();
	
	debug("fat ok ?");
	
	// si le systeme de fichier est bien FAT
	if((fat_ok == PNGU_OK) || (fat_ok == PNGU_ALREADY_INITIALIZED))
	{
		memset(&finfo, 0, sizeof(finfo));
		
		debug(chemin);
	
		// si le fichier existe
		if(f_stat(chemin, &finfo) == FR_OK)
		{
			debug("Fichier nbrniv.txt trouve");
						
			// si l'ouverture du fichier nbr_plateau.txt reussi
			if(f_open(&fichier_nbr_plateau,chemin,FA_READ) == FR_OK)
			{
				bytes_read = bytes_read_total = 0;
				
				// tant qu'on a pas atteint la fin du fichier et tant qu'il n'y a pas eu d'erreur
				while((bytes_read_total < finfo.fsize) && (erreur == FALSE))
				{
					// on lit
					if(f_read(&fichier_nbr_plateau, data + bytes_read_total, 0x200, &bytes_read) != FR_OK)
					{
						erreur = TRUE;
					}
					
					// si on n'a rien lu
					if(bytes_read == 0)
						break;
						
					bytes_read_total += bytes_read;
				}
				
				// si on a lu autant que la taille du fichier
				if((bytes_read_total >= finfo.fsize) && (erreur == FALSE))
				{
					recherche = strstr(data,"nbr_plateau=");
					
					nbr_plateau = get_int_in_string(recherche+12);
					sprintf(chemin,"nbr plateau : %d",nbr_plateau);
					debug(chemin);
				}
			}
		}
	}
}

char charger_plateau(int n)
{
	char reussi = FALSE;
	char erreur = FALSE;
	int i, lig, col;
	int fat_ok = -1;
	
	FIL config;
	FILINFO finfo;
	
	WORD bytes_read;
	u32 bytes_read_total;
	u8 *data = (u8 *)0x92000000;
	char* recherche;
	
	char filename[50];
	
	debug("chargement en cours......");
	
	niveau.num = 0;
	
	sprintf(filename, "%s/plateau%d/config.txt", repertoire_jeu, n);
	
	fat_ok = PNGU_Init();
	
	// si le systeme de fichier est bien FAT
	if((fat_ok == PNGU_OK) || (fat_ok == PNGU_ALREADY_INITIALIZED))
	{
		debug("FAT OK");
		
		memset(&finfo, 0, sizeof(finfo));

		debug(filename);
		
		// si le fichier config.txt et le fichier fond.png existe
		if(f_stat(filename, &finfo) == FR_OK)
		{
			debug("Fichier config.txt trouve");
						
			// si l'ouverture du fichier config.txt reussi
			if(f_open(&config,filename,FA_READ) == FR_OK)
			{
				debug("Ouverture du fichier config.txt reussi");
			
				bytes_read = bytes_read_total = 0;
				
				// tant qu'on a pas atteint la fin du fichier et tant qu'il n'y a pas eu d'erreur
				while((bytes_read_total < finfo.fsize) && (erreur == FALSE))
				{
					// on lit
					if(f_read(&config, data + bytes_read_total, 0x200, &bytes_read) != FR_OK)
					{
						erreur = TRUE;
					}
					
					// si on n'a rien lu
					if(bytes_read == 0)
						break;
						
					bytes_read_total += bytes_read;
				}
				
				// si on a lu autant que la taille du fichier
				if((bytes_read_total >= finfo.fsize) && (erreur == FALSE))
				{
					debug("Lecture du fichier config.txt reussi");
				
					// numero du niveau
					niveau.num = n;
					
					niveau.fond_x = get_int_in_string(data+7);
					
					recherche = strstr(data,"fond_y=");
					niveau.fond_y = get_int_in_string(recherche+7);
												
					recherche = strstr(data,"plateau_x=");
					niveau.plateau_x = get_int_in_string(recherche+10);
					
					recherche = strstr(data,"plateau_y=");
					niveau.plateau_y = get_int_in_string(recherche+10);
					
					recherche = strstr(data,"dragon_x=");
					niveau.dragon_x = get_int_in_string(recherche+9);
					
					recherche = strstr(data,"dragon_y=");
					niveau.dragon_y = get_int_in_string(recherche+9);
					
					recherche = strstr(data,"temps_x=");
					niveau.temps_x = get_int_in_string(recherche+8);
					
					recherche = strstr(data,"temps_y=");
					niveau.temps_y = get_int_in_string(recherche+8);
					
					recherche = strstr(data,"vie_x=");
					niveau.vie_x = get_int_in_string(recherche+6);
					
					recherche = strstr(data,"vie_y=");
					niveau.vie_y = get_int_in_string(recherche+6);
					
					recherche = strstr(data,"score_x=");
					niveau.score_x = get_int_in_string(recherche+8);
					
					recherche = strstr(data,"score_y=");
					niveau.score_y = get_int_in_string(recherche+8);
					
					recherche = strstr(data,"temps=");
					niveau.temps = get_int_in_string(recherche+6);
					
					recherche = strstr(data,"nbr_motif=");
					niveau.nbr_motif = get_int_in_string(recherche+10);
					recherche = recherche+10;
					
					for(i=0;i<niveau.nbr_motif;i++)
					{
						recherche = strstr(recherche,"motif=");
						niveau.motif[i] = get_int_in_string(recherche+6);
						recherche = recherche+6;
					}
					
					// motif aleatoire
					niveau.motif_aleatoire = (niveau.nbr_motif*2);
					
					// case hors limite
					niveau.hors_limite = (niveau.motif_aleatoire+1);
					// case vide
					niveau.case_vide = (niveau.motif_aleatoire+2);
					
					recherche = strstr(data,"nbr_lig=");
					niveau.nbr_lig = get_int_in_string(recherche+8);
					
					recherche = strstr(data,"nbr_col=");
					niveau.nbr_col = get_int_in_string(recherche+8);
					
					recherche = strstr(recherche,",");
					recherche = recherche-1;
					
					debug("Init case tableau");
					
					// initialisation des cases du tableau
					for(lig=0;lig<niveau.nbr_lig;lig++)
					{
						for(col=0;col<niveau.nbr_col;col++)
						{
							decheck_case(lig,col);
							debloque_case(lig,col);
							
							//debug(recherche);
							
							// si c'est une case hors limite
							if(recherche[0] == 'X')
							{
								set_motif(lig,col,niveau.hors_limite);
							}
							// sinon
							else 
							{
								// motif aleatoire
								set_motif(lig,col,niveau.motif_aleatoire);
								
								//  si c'est une case bloque
								if(recherche[0] == 'B')
								{
									bloque_case(lig,col);
								}
							}
							
							recherche = recherche+2;
						}
						
						recherche = recherche+1;
					}
					
					while(check_plateau() == TRUE)
					{
						// on valide, on compte les points et on vide les cases checkes
						valide_et_vide_case_check(TRUE);
					
						// on descend les cases non vide et on rempli de motif aleatoire les cases vides
						cascade_plateau();
					}
				}
				
				f_close(&config);
				
				debug("Lecture du fichier config.txt termine");
			}
		}
	}
	
	/*sprintf(filename, "fond_x trouve = %d", niveau.fond_x);
	debug(filename);
	
	sprintf(filename, "fond_y trouve = %d", niveau.fond_y);
	debug(filename);
	
	sprintf(filename, "plateau_x trouve = %d", niveau.plateau_x);
	debug(filename);
	
	sprintf(filename, "plateau_y trouve = %d", niveau.plateau_y);
	debug(filename);
	
	sprintf(filename, "dragon_x trouve = %d", niveau.dragon_x);
	debug(filename);
	
	sprintf(filename, "dragon_y trouve = %d", niveau.dragon_y);
	debug(filename);
	
	sprintf(filename, "temps_x trouve = %d", niveau.temps_x);
	debug(filename);
	
	sprintf(filename, "vie_x trouve = %d", niveau.vie_x);
	debug(filename);
	
	sprintf(filename, "vie_y trouve = %d", niveau.vie_y);
	debug(filename);
	
	sprintf(filename, "score_x trouve = %d", niveau.score_x);
	debug(filename);
	
	sprintf(filename, "score_y trouve = %d", niveau.score_y);
	debug(filename);
	
	sprintf(filename, "nbr_motif trouve = %d", niveau.nbr_motif);
	debug(filename);
	
	for(i=0;i<niveau.nbr_motif;i++)
	{
		sprintf(filename, "motif %d trouve = %d", i, niveau.motif[i]);
		debug(filename);
	}
	
	sprintf(filename, "motif_aleatoire trouve = %d", niveau.motif_aleatoire);
	debug(filename);
	
	sprintf(filename, "hors_limite hors_limite = %d", niveau.hors_limite);
	debug(filename);
	
	sprintf(filename, "case_vide trouve = %d", niveau.case_vide);
	debug(filename);
	
	sprintf(filename, "nbr_lig trouve = %d", niveau.nbr_lig);
	debug(filename);
	
	sprintf(filename, "nbr_col trouve = %d", niveau.nbr_col);
	debug(filename);*/
			
	reussi = charger_fond_plateau(n);

	debug("chargement termin...");
	
	return reussi;
}

char charger_fond_plateau(int n)
{
	int fat_ok = -1;
	int decode_ok = -1;
	PNGUPROP imgProp;
	char temp_str[50];
	char reussi = FALSE;
	
	sprintf(temp_str, "%s/plateau%d/fond.png", repertoire_jeu, n);
	
	fat_ok = PNGU_Init();
	
	// si le systeme de fichier est bien FAT
	if((fat_ok == PNGU_OK) || (fat_ok == PNGU_ALREADY_INITIALIZED))
	{
		// si l'ouverture du fichier fond.png reussi
		if(PNGU_SelectFileFromWiiSD (temp_str) == PNGU_OK)
		{
			debug("Ouverture du fichier fond.png reussi");
			
			// proprit de l'image
			if(PNGU_GetImageProperties (&imgProp) == PNGU_OK)
			{
				sprintf(temp_str, "Propriete image : %d/%d/%d/%d", imgProp.imgWidth, imgProp.imgHeight,imgProp.imgBitDepth,imgProp.nbr_bytes_for_row);
				
				debug(temp_str);
				
				// allocation de mmoire
				fond_plateau = memalign (32, imgProp.imgWidth * imgProp.imgHeight * 2);
				
				debug("Allocation memoire ok");
												
				decode_ok = PNGU_DecodeToRGB565 (imgProp.imgWidth, imgProp.imgHeight, fond_plateau);
									
				if(decode_ok == PNGU_OK)
				{
					debug("pngu decode ok");
					DCFlushRange (fond_plateau, imgProp.imgWidth * imgProp.imgHeight * 2);
					
					reussi = TRUE;
				}
				else
				{
					sprintf(temp_str, "pngu decode oups : %d", decode_ok);
					debug(temp_str);
				}
				
				fond_plateau_width = imgProp.imgWidth;
				fond_plateau_height = imgProp.imgHeight;
				
				debug("width et height ok");
			}
		}
	}
	
	return reussi;
}

void init_game()
{
	int lig, col;
	
	// on devalide toutes les cases et on initialise les positions
	for(lig=0;lig<niveau.nbr_lig;lig++)
	{
		for(col=0;col<niveau.nbr_col;col++)
		{
			devalide_case(lig,col);
			
			if(lig == 0)
			{
				// position en y - (MOTIF_HEIGHT*2)  pour l'animation du plateau
				set_position_y_case(lig,col,niveau.plateau_y+(MOTIF_HEIGHT*lig)-MOTIF_HEIGHT);
			}
			else
			{
				// position en y par rapport a celle d'au dessus
				set_position_y_case(lig,col,get_position_y_case(lig-1,col)+MOTIF_HEIGHT);
			}
			
			// position en x
			set_position_x_case(lig,col,niveau.plateau_x+(MOTIF_WIDTH*col));
		}
	}
	
	// joueur sur la premiere case
	gamer.lig = 0;
	gamer.col = 0;
	gamer.select = FALSE;
	gamer.temps = 0;
	gamer.termine = FALSE;
	gamer.gagne = FALSE;
	gamer.rejouer = TRUE;
}

void set_position_y_case(int lig, int col, int y)
{
	niveau.position_y[lig][col] = y;
}

int get_position_y_case(int lig, int col)
{
	return niveau.position_y[lig][col];
}

void set_position_x_case(int lig, int col, int x)
{
	niveau.position_x[lig][col] = x;
}

int get_position_x_case(int lig, int col)
{
	return niveau.position_x[lig][col];
}

char get_motif(int lig, int col)
{
	if((0 <= lig) && (lig < niveau.nbr_lig) 
		&& (0 <= col) && (col < niveau.nbr_col))
	{	
		return niveau.plateau[lig][col];
	}

	return niveau.hors_limite;
}

void set_motif(int lig, int col, char motif)
{
	if(motif == niveau.motif_aleatoire)
	{
		niveau.plateau[lig][col] = GRRLIB_Rand(niveau.nbr_motif);
	}
	else
	{
		niveau.plateau[lig][col] = motif;
	}
}

int get_score(int lig, int col)
{
	// si c'est une case hors limite ou si elle est bloque
	if((get_motif(lig,col) == niveau.hors_limite) || (is_bloque(lig,col) == TRUE))
	{
		return 0;
	}
	
	// si la case a dj t valid
	if(is_valide(lig,col) == TRUE)
	{
		// 3 point de plus au score
		return 3;
	}
	else
	{
		// 51 point de plus au score
		return 51;
	}
}

void inverse(int lig, int col, int lig1, int col1)
{
	char temp;
	//int x_temp, y_temp;
	
	// inverse les motifs
	temp = get_motif(lig,col);
	set_motif(lig, col, get_motif(lig1,col1));
	set_motif(lig1, col1, temp);
	
	// inverse les positions
	/*x_temp = get_position_x_case(lig,col);
	y_temp = get_position_y_case(lig,col);
	set_position_x_case(lig,col,get_position_x_case(lig1,col1));
	set_position_y_case(lig,col,get_position_y_case(lig1,col1));
	set_position_x_case(lig1,col1,x_temp);
	set_position_y_case(lig1,col1,y_temp);*/
}

// retourne true si la case est vide
char is_vide(int lig, int col)
{
	if(get_motif(lig,col) == niveau.case_vide)
	{
		return TRUE;
	}

	return FALSE;
}

// retourne true si la case est check
char is_checked(int lig, int col)
{	
	return niveau.plateau_cases_check[lig][col];
}

// retourne true si la case est valid
char is_valide(int lig, int col)
{
	return niveau.plateau_cases_validees[lig][col];
}

char is_bloque(int lig, int col)
{
	return niveau.plateau_cases_bloquees[lig][col];
}

// valide la case
void valide_case(int lig, int col)
{
	niveau.plateau_cases_validees[lig][col] = TRUE;
}

void devalide_case(int lig, int col)
{
	niveau.plateau_cases_validees[lig][col] = FALSE;
}

void bloque_case(int lig, int col)
{
	niveau.plateau_cases_bloquees[lig][col] = TRUE;
}

void debloque_case(int lig, int col)
{
	niveau.plateau_cases_bloquees[lig][col] = FALSE;
}

void check_case(int lig, int col)
{
	niveau.plateau_cases_check[lig][col] = TRUE;
}

void decheck_case(int lig, int col)
{
	niveau.plateau_cases_check[lig][col] = FALSE;
}

// check les cases, de lig_deb a lig_ fin inclus, qui ne sont pas checkes et laisse les cases checkes dans leur tat
void check_case_lig(int lig_deb, int lig_fin, int col)
{
	int lig;
	
	for(lig=lig_deb;lig<=lig_fin;lig++)
	{
		check_case(lig,col);
	}
}

// check les cases, de col_deb a col_ fin inclus, qui ne sont pas checkes et laisse les cases checkes dans leur tat
void check_case_col(int col_deb, int col_fin, int lig)
{
	int col;

	for(col=col_deb;col<=col_fin;col++)
	{
		check_case(lig,col);
	}
}

// check le plateau, si des cases ont t checkes renvoie TRUE sinon FALSE
char check_plateau()
{
	int lig, col;
	int temp = 0;
	int nbr_meme = 0;
	char meme = FALSE;
	char ancien_motif = niveau.hors_limite;
	char ok = FALSE;
	
	// parcours en ligne
	for(lig=0;lig<niveau.nbr_lig;lig++)
	{
		ancien_motif = niveau.hors_limite;
		nbr_meme = 0;
		
		for(col=0;col<niveau.nbr_col;col++)
		{
			meme = FALSE;
			
			// si le motif de la case courante est le meme que celui de la case prcdente
			if((ancien_motif != niveau.hors_limite) && (get_motif(lig,col) == ancien_motif))
			{
				nbr_meme++;
				meme = TRUE;
			}
			
			// si le nombre de motif pareil est superieur ou egal a 2 et que la case courante ne contient pas le meme motif
			// que l'ancien
			if((nbr_meme >= 2) && (meme == FALSE))
			{
				// colonne de depart
				temp = col-(nbr_meme+1);
				
				// check les cases jusqu'a la case precedente
				check_case_col(temp, col-1, lig);
				
				// il y a au moins un ligne check
				ok = TRUE;
			}
			// sinon si le nombre de motif pareil est superieur ou egal a 2 et que la case courante se trouve etre la derniere
			else if((nbr_meme >= 2) && ((col == (niveau.nbr_col-1)) || (get_motif(lig,col+1) == niveau.hors_limite)))
			{
				// colonne de depart
				temp = col-nbr_meme;
				
				// check les cases jusqu'a la case courante
				check_case_col(temp, col, lig);
				
				// il y a au moins un ligne check
				ok = TRUE;
			}
			
			// si le motif de la case courante n'est pas le meme que l'ancien
			if(meme == FALSE)
			{
				// on remet le nombre de meme motif a 0
				nbr_meme = 0;
			}
			
			ancien_motif = get_motif(lig,col);
		}
	}
	
	// parcours en colonne
	for(col=0;col<niveau.nbr_col;col++)
	{
		ancien_motif = niveau.hors_limite;
		nbr_meme = 0;
		
		for(lig=0;lig<niveau.nbr_lig;lig++)
		{
			meme = FALSE;
			
			// si le motif de la case courante est le meme que celui de la case prcdente
			if((ancien_motif != niveau.hors_limite) && (get_motif(lig,col) == ancien_motif))
			{
				nbr_meme++;
				meme = TRUE;
			}
			
			// si le nombre de motif pareil est superieur ou egal a 2 et que la case courante ne contient pas le meme motif
			// que l'ancien
			if((nbr_meme >= 2) && (meme == FALSE))
			{
				// ligne de depart
				temp = lig-(nbr_meme+1);
				
				// check les cases jusqu'a la case precedente
				check_case_lig(temp, lig-1, col);
				
				// il y a au moins un ligne check
				ok = TRUE;
			}
			// sinon si le nombre de motif pareil est superieur ou egal a 2 et que la case courante se trouve etre la derniere
			else if((nbr_meme >= 2) && (lig == (niveau.nbr_lig-1)))
			{
				// colonne de depart
				temp = lig-nbr_meme;
				
				// check les cases jusqu'a la case courante
				check_case_lig(temp, lig, col);
				
				// il y a au moins un ligne check
				ok = TRUE;
			}
			
			// si le motif de la case courante n'est pas le meme que l'ancien
			if(meme == FALSE)
			{
				// on remet le nombre de meme motif a 0
				nbr_meme = 0;
			}
			
			ancien_motif = get_motif(lig,col);
		}
	}

	return ok;
}

void valide_et_vide_case_check(char init)
{
	int lig, col;
	
	for(lig=0;lig<niveau.nbr_lig;lig++)
	{		
		for(col=0;col<niveau.nbr_col;col++)
		{
			// si la case est check
			if(is_checked(lig,col) == TRUE)
			{
				// si on ne charge pas le plateau
				if(init == FALSE)
				{
					// on compte les points du joueur
					gamer.score += get_score(lig,col);
				}
				
				// si la case n'est pas bloque
				if(is_bloque(lig,col) == FALSE)
				{
					// on la valide
					valide_case(lig,col);
					
					// et on la vide
					set_motif(lig,col,niveau.case_vide);
				}
				// sinon si elle est bloque et que cette methode n'est pas apeller lors du chargement du plateau
				else if(init == FALSE)
				{
					// on la debloque
					debloque_case(lig,col);
				}
				
				// on enleve le check sur la case
				decheck_case(lig,col);
			}
		}
	}
}

// descend les cases non vide de toutes les colonnes et rempli de motif aleatoire les cases vides
void cascade_plateau()
{
	int col;
	
	// pour chaque colonne 
	for(col=0;col<niveau.nbr_col;col++)
	{
		cascade_col(col);
	}
}

// descend les cases non vide de la colonne et rempli de motif aleatoire les cases vides
void cascade_col(int col)
{
	int lig, lig_vide, lig_non_vide;
	
	char case_vide_trouve = FALSE;
	char case_non_vide_trouve = FALSE;
	
	// a peu pres tous les cas :
	// V		X		B		X		R		V		V		V		R		R
	// R		X		X		X		V		X		V		Hors_Lim	X		V
	// X		X		V		X		B		V		Hors_Lim	X		Hors_Lim	Hors_Lim
	// X		V		B		X		B		X		X		Hors_Lim	V		X
	// X		R		X		X		V		R		X		R		Hors_Lim	X
	// X		V		X		X		V		X		X		X		X		X
	
	// resultat
	// X		X		X		X		R		X		V		V		X		
	// X		X		X		X		V		X		V		Hors_Lim	R		
	// X		X		X		X		B		X		Hors_Lim	X		Hors_Lim	
	// X		V		B		X		B		V		X		Hors_Lim	V		
	// V		R		V		X		V		V		X		X		Hors_Lim	
	// R		V		B		X		V		R		X		R		X		
	
	// OK	OK		OK		OK		OK		OK		OK		OK		OK
	
	// on pars du bas de la ligne
	lig_vide = (niveau.nbr_lig-1);
	
	do
	{
		case_vide_trouve = FALSE;
		case_non_vide_trouve = FALSE;
		
		// tant qu'on a pas trouve une case vide
		while((lig_vide >= 0) && (case_vide_trouve == FALSE))
		{
			// si la case est vide alors case_vide_trouve = TRUE
			case_vide_trouve = is_vide(lig_vide,col);
			
			lig_vide--;
		}
		
		lig_non_vide = lig_vide;
		
		// tant qu'on a pas trouve une case non vide
		while((lig_non_vide >= 0) && (case_non_vide_trouve == FALSE))
		{
			// si la case n'est pas vide et que ce n'est pas un motif hors limite
			if((is_vide(lig_non_vide,col) == FALSE) && (get_motif(lig_non_vide,col) != niveau.hors_limite))
			{
				case_non_vide_trouve = TRUE;
			}
			// sinon si le motif de la case est hors limite
			else if(get_motif(lig_non_vide,col) == niveau.hors_limite)
			{
				// la ligne vide est celle au dessus au minimum
				lig_vide = lig_non_vide-1;
				// on sort
				case_non_vide_trouve = TRUE;
			}
			
			lig_non_vide--;
		}
		
		// si la case vide est plus bas que la case non vide
		if((lig_vide > lig_non_vide) && (case_non_vide_trouve == TRUE))
		{
			// on inverse
			// on met le motif de la case non vide dans la case vide
			// et on vide la case non vide
			inverse(lig_vide+1, col, lig_non_vide+1, col);
		}
	}
	// tant que je ne suis pas arriv en haut de la ligne
	while((lig_vide > 0) && (lig_non_vide >= 0));
	
	// pour chaque case de la colonne
	for(lig=0;lig<niveau.nbr_lig;lig++)
	{
		// si elle est vide
		if(is_vide(lig,col) == TRUE)
		{
			// on rempli la case d'un motif aleatoire
			set_motif(lig,col,niveau.motif_aleatoire);
		}
	}
}

// renvoie false si une des cases n'a pas ete valide
char is_all_valide()
{
	char valide = TRUE;
	int lig, col;
	
	lig = 0;
	
	while((lig < niveau.nbr_lig) && (valide == TRUE))
	{
		col = 0;
		
		while((col < niveau.nbr_col) && (valide == TRUE))
		{
			if((get_motif(lig,col) != niveau.hors_limite) && (is_valide(lig,col) == FALSE))
			{
				valide = FALSE;
			}
			
			col++;
		}
		
		lig++;
	}
	
	return valide;
}

void inverse_si_ok(int lig, int col, int lig1, int col1)
{
	char check = FALSE;

	// si les cases a invers se trouve bien sur le plateau
	if((0 <= lig) && (lig < niveau.nbr_lig) 
		&& (0 <= col) && (col < niveau.nbr_col)
		&& (0 <= lig1) && (lig1 < niveau.nbr_lig) 
		&& (0 <= col1) && (col1 < niveau.nbr_col))
	{	
		// si aucune des deux cases n'est bloqu
		if((is_bloque(lig,col) == FALSE) && (is_bloque(lig1,col1) == FALSE))
		{
			// animation inversions des cases
			animation_inverse(lig, col, lig1, col1);
			
			// on les inverses
			inverse(lig, col, lig1, col1);
			
			// si l'utilisateur a valid des cases sur le plateau
			while(check_plateau() == TRUE)
			{
				// animation des cases check pendant x ms
				animation_check_plateau(500);
				
				// on valide, on compte les points et on vide les cases checkes
				valide_et_vide_case_check(FALSE);
			
				// on descend les cases non vide et on rempli de motif aleatoire les cases vides
				cascade_plateau();
				
				check = TRUE;
			}
			
			// si le joueur a le droit d'inverser les motifs
			if(check == TRUE)
			{
				// on change la position ou il se trouve
				gamer.lig = lig1;
				gamer.col = col1;
			}
			// sinon
			else
			{
				// animation inversions des cases
				animation_inverse(lig, col, lig1, col1);
			
				// on revient a l'etat d'origine
				inverse(lig, col, lig1, col1);
			}
			
			gamer.termine = is_all_valide();
		}
	}
	
	gamer.select = FALSE;
}

/******************** DESSIN ET ANIMATION ********************/
void debug_fond(u16 data[])
{
	char temp[50];
	int ni = 0;
	int x,y;
	
	debug("debug fond");
	for(y=0;y<fond_plateau_height;y++)
	{
			for(x=0;x<fond_plateau_width;x++)
			{
					sprintf(temp,"couleur %d,%d: %#x", x,y,data[ni]);
					debug(temp);

					ni++;
			}
	}	
}

void dessine_fond()
{
	if(fond_plateau != NULL)
	{
		GRRLIB_DrawImg(niveau.fond_x,niveau.fond_y, fond_plateau_width, fond_plateau_height, fond_plateau,0,1);
	}	
}

void dessine_plateau(char img_case_check, char animation)
{
	int lig, col;
	double taille = 1.0;
	double rotation = 0.0;
	
	char buffer_score[8];
	
	// on dessine d'abord les cases en or (oblig a cause de l'animation lorsqu'on inverse sinon le motif passe derrire la case)
	for(lig=0;lig<niveau.nbr_lig;lig++)
	{
		for(col=0;col<niveau.nbr_col;col++)
		{
			// si cette case est valide
			if(is_valide(lig,col) == TRUE)
			{
				// dessine case or derriere le motif
				GRRLIB_DrawImg(niveau.plateau_x+(col*MOTIF_WIDTH),niveau.plateau_y+(lig*MOTIF_HEIGHT), MOTIF_WIDTH, MOTIF_HEIGHT, case_or_img,0,1);
			}
		}
	}
	
	for(lig=0;lig<niveau.nbr_lig;lig++)
	{
		for(col=0;col<niveau.nbr_col;col++)
		{				
			// si il n'y a pas d'animation
			if(animation == FALSE)
			{
				if((gamer.lig == lig) && (gamer.col == col))
				{
					// si le joueur a selectionner la case
					if(gamer.select)
					{
						// case verte
						GRRLIB_DrawImg(get_position_x_case(lig,col),get_position_y_case(lig,col), MOTIF_WIDTH, MOTIF_HEIGHT, case_vert_img,0,1);
					}
					else
					{
						// case rouge
						GRRLIB_DrawImg(get_position_x_case(lig,col),get_position_y_case(lig,col), MOTIF_WIDTH, MOTIF_HEIGHT, case_rouge_img,0,1);
					}
				}
			}
		
			taille = 1.0;
			rotation = 0.0;
			
			// si la case est checke et qu'elle n'est pas bloque
			if((is_checked(lig,col) == TRUE) && (is_bloque(lig,col) == FALSE))
			{
				// si on connait l'image de l'animation
				if(img_case_check > 0)
				{
					// taille de l'image
					taille = 1.0/(1.0+((img_case_check-1)*0.5));
					// roation de l'image
					rotation = (img_case_check-1)*45;
					
					// si elle n'est pas bloque
					if(is_bloque(lig,col) == FALSE)
					{
						// on ecrit le score obtenu pour la case
						sprintf(buffer_score,"+%d",get_score(lig,col));
						GRRLIB_Print(niveau.plateau_x+(col*MOTIF_WIDTH)+(MOTIF_WIDTH/2)-((font5_char_width*strlen(buffer_score))/2),niveau.plateau_y+(lig*MOTIF_HEIGHT)+(MOTIF_HEIGHT/2)-(font5_char_high/2)-((img_case_check-1)*4.0), font5_char_width,font5_char_high,buffer_score,font5,0x0000,0xf01e);
					}
				}
				// sinon
				else
				{
					// on n'affiche pas l'image
					taille = 0;
				}
			}			
			
			// si c'est une tete bleu
			if(get_motif(lig,col) == TETE_B)
			{
				// si la case est bloque
				if(is_bloque(lig,col) == TRUE)
				{
					// on dessine l'image de la tete grise
					GRRLIB_DrawImg(get_position_x_case(lig,col),get_position_y_case(lig,col), MOTIF_WIDTH, MOTIF_HEIGHT, tete_b_grise_img,rotation,taille);
				}
				else
				{
					// on dessine l'image de la tete
					GRRLIB_DrawImg(get_position_x_case(lig,col),get_position_y_case(lig,col), MOTIF_WIDTH, MOTIF_HEIGHT, tete_b_img,rotation,taille);
				}
			}
			// sinon si c'est une tete de mort
			else if(get_motif(lig,col) == TETE_M)
			{
				// si la case est bloque
				if(is_bloque(lig,col) == TRUE)
				{
					// on dessine l'image de la tete grise
					GRRLIB_DrawImg(get_position_x_case(lig,col),get_position_y_case(lig,col), MOTIF_WIDTH, MOTIF_HEIGHT, tete_m_grise_img,rotation,taille);
				}
				else
				{
					// on dessine l'image de la tete
					GRRLIB_DrawImg(get_position_x_case(lig,col),get_position_y_case(lig,col), MOTIF_WIDTH, MOTIF_HEIGHT, tete_m_img,rotation,taille);
				}
			}
			// sinon si c'est une emeraude
			else if(get_motif(lig,col) == EMERAUDE)
			{
				// si la case est bloque
				if(is_bloque(lig,col) == TRUE)
				{
					// on dessine l'image de l'emeraude grise
					GRRLIB_DrawImg(get_position_x_case(lig,col),get_position_y_case(lig,col), MOTIF_WIDTH, MOTIF_HEIGHT, emeraude_grise_img,rotation,taille);
				}
				else
				{
					// on dessine l'image de l'emeraude
					GRRLIB_DrawImg(get_position_x_case(lig,col),get_position_y_case(lig,col), MOTIF_WIDTH, MOTIF_HEIGHT, emeraude_img,rotation,taille);
				}
			}
			// sinon si c'est une piece
			else if(get_motif(lig,col) == PIECE)
			{
				// si la case est bloque
				if(is_bloque(lig,col) == TRUE)
				{
					// on dessine l'image de la piece grise
					GRRLIB_DrawImg(get_position_x_case(lig,col),get_position_y_case(lig,col), MOTIF_WIDTH, MOTIF_HEIGHT, piece_grise_img,rotation,taille);
				}
				else
				{
					// on dessine l'image de la piece
					GRRLIB_DrawImg(get_position_x_case(lig,col),get_position_y_case(lig,col), MOTIF_WIDTH, MOTIF_HEIGHT, piece_img,rotation,taille);
				}
			}
			// sinon si c'est un rubi
			else if(get_motif(lig,col) == SAPHIR)
			{
				// si la case est bloque
				if(is_bloque(lig,col) == TRUE)
				{
					// on dessine l'image du saphir grise
					GRRLIB_DrawImg(get_position_x_case(lig,col),get_position_y_case(lig,col), MOTIF_WIDTH, MOTIF_HEIGHT, saphir_grise_img,rotation,taille);
				}
				else
				{
					// on dessine l'image du saphir
					GRRLIB_DrawImg(get_position_x_case(lig,col),get_position_y_case(lig,col), MOTIF_WIDTH, MOTIF_HEIGHT, saphir_img,rotation,taille);
				}
			}
		}
	}
}

void dessine_temps()
{
	int i, nbr_fois;

	// si le temps n'est pas termine
	if((niveau.temps - gamer.temps) > 0)
	{
		// niveau.temps = 112 fois
		//  X = nbr_fois
		nbr_fois = (int)round((((double)(niveau.temps - gamer.temps))*112.0)/niveau.temps);
		
		for(i=0;i<nbr_fois;i++)
		{
			// langue du temps
			GRRLIB_DrawImg(niveau.temps_x+i, niveau.temps_y, langue_debut_width, langue_debut_high, langue_debut_img,0,1);
		}
		
		// bout de la langue
		GRRLIB_DrawImg(niveau.temps_x+i, niveau.temps_y, langue_fin_width, langue_fin_high, langue_fin_img,0,1);
		
		// tete du dragon bouche ouverte
		GRRLIB_DrawImg(niveau.dragon_x, niveau.dragon_y, 41, 35, tete_dragon_img,0,1);
	}
	else
	{
		// tete du dragon bouche ferme
		GRRLIB_DrawImg(niveau.dragon_x, niveau.dragon_y, 41, 35, tete_dragon_ferme_img,0,1);
	}
}

void dessine_infos()
{
	char buffer[50];
	time_t courant;
	double diff_temps;
	
	// si le joueur n'a pas encore termin
	if(gamer.termine == FALSE)
	{
		// recupere le temps pour faire la difference
		time(&courant);
		
		// difference de temps
		diff_temps = difftime(courant,start_game);
				
		gamer.temps = diff_temps;
	}
	
	dessine_temps();
	
	sprintf (buffer,"%d", gamer.vie);
	GRRLIB_Print(niveau.vie_x, niveau.vie_y, font5_char_width,font5_char_high,buffer,font5,0xfe00,0xf01e);
	
	sprintf (buffer,"%d", gamer.score);
	GRRLIB_Print(niveau.score_x, niveau.score_y, font5_char_width,font5_char_high,buffer,font5,0xfe00,0xf01e);
}

void dessine_pret()
{
	GRRLIB_DrawImg(niveau.plateau_x+((niveau.nbr_col*MOTIF_WIDTH)/2)-(pret_width/2),niveau.plateau_y+((niveau.nbr_lig*MOTIF_HEIGHT)/2)-(pret_high/2), pret_width, pret_high, pret_img,0,1);
}

void dessine_ok()
{
	GRRLIB_DrawImg(niveau.plateau_x+((niveau.nbr_col*MOTIF_WIDTH)/2)-(ok_width/2),niveau.plateau_y+((niveau.nbr_lig*MOTIF_HEIGHT)/2)-(ok_high/2), ok_width, ok_high, ok_img,0,1);
}

void dessine_termine()
{
	GRRLIB_DrawImg(niveau.plateau_x+((niveau.nbr_col*MOTIF_WIDTH)/2)-(termine_width/2),niveau.plateau_y+((niveau.nbr_lig*MOTIF_HEIGHT)/2)-(termine_high/2), termine_width, termine_high, termine_img,0,1);
}

void dessine_cest_fini()
{
	GRRLIB_DrawImg(niveau.plateau_x+((niveau.nbr_col*MOTIF_WIDTH)/2)-(cest_fini_width/2),niveau.plateau_y+((niveau.nbr_lig*MOTIF_HEIGHT)/2)-(cest_fini_high/2), cest_fini_width, cest_fini_high, cest_fini_img,0,1);
}

void dessine_menu_fin()
{
	// si le joueur veut rejouer
	if(gamer.rejouer == TRUE)
	{
		// rejouer en rouge
		GRRLIB_Print(niveau.plateau_x+((niveau.nbr_col*MOTIF_WIDTH)/2)-(3*font5_char_width), niveau.plateau_y+((niveau.nbr_lig*MOTIF_HEIGHT)/2)+(2*MOTIF_HEIGHT), font5_char_width,font5_char_high,"Rejouer",font5,0xf800,0xf01e);
		
		// quitter en noir
		GRRLIB_Print(niveau.plateau_x+((niveau.nbr_col*MOTIF_WIDTH)/2)-(3*font5_char_width), niveau.plateau_y+((niveau.nbr_lig*MOTIF_HEIGHT)/2)+(2*MOTIF_HEIGHT)+(2*font5_char_high), font5_char_width,font5_char_high,"Quitter",font5,0xFFFF,0xf01e);
	}
	else
	{
		// rejouer en noir
		GRRLIB_Print(niveau.plateau_x+((niveau.nbr_col*MOTIF_WIDTH)/2)-(3*font5_char_width), niveau.plateau_y+((niveau.nbr_lig*MOTIF_HEIGHT)/2)+(2*MOTIF_HEIGHT), font5_char_width,font5_char_high,"Rejouer",font5,0xFFFF,0xf01e);
		
		// quitter en rouge
		GRRLIB_Print(niveau.plateau_x+((niveau.nbr_col*MOTIF_WIDTH)/2)-(3*font5_char_width), niveau.plateau_y+((niveau.nbr_lig*MOTIF_HEIGHT)/2)+(2*MOTIF_HEIGHT)+(2*font5_char_high), font5_char_width,font5_char_high,"Quitter",font5,0xf800,0xf01e);
	}
}

void dessine_bonus(int score)
{
	int temp, i, posX;
	char string_score[8];
	
	sprintf(string_score,"%d",score);
	
	// nombre de caractere a afficher
	temp = strlen(string_score);
	
	// position en x du dernier chiffre
	posX = niveau.plateau_x+((niveau.nbr_col*MOTIF_WIDTH)/2);
	
	// affiche "Bonus : "
	GRRLIB_DrawImg(niveau.plateau_x+((niveau.nbr_col*MOTIF_WIDTH)/2)-(bonus_width/2),niveau.plateau_y+((niveau.nbr_lig*MOTIF_HEIGHT)/2)-(bonus_high/2), bonus_width, bonus_high, bonus_img,0,1);
	
	i = temp;
	
	// affiche les chiffres
	while(i > 0)
	{
		GRRLIB_DrawImg(posX,niveau.plateau_y+((niveau.nbr_lig*MOTIF_HEIGHT)/2)-(bonus_high/2)+bonus_high, zero_width, zero_high, get_img_chiffre_bonus(string_score[i-1]),0,1);
	
		posX -= (zero_width-(zero_width/2));
		i--;
	}
}

const u16* get_img_chiffre_bonus(char chiffre)
{
	if(chiffre == '1')
	{
		return un_img;
	}
	else if(chiffre == '2')
	{
		return deux_img;
	}
	else if(chiffre == '3')
	{
		return trois_img;
	}
	else if(chiffre == '4')
	{
		return quatre_img;
	}
	else if(chiffre == '5')
	{
		return cinq_img;
	}
	else if(chiffre == '6')
	{
		return six_img;
	}
	else if(chiffre == '7')
	{
		return sept_img;
	}
	else if(chiffre == '8')
	{
		return huit_img;
	}
	else if(chiffre == '9')
	{
		return neuf_img;
	}
	
	return zero_img;
}

void animation_plateau()
{
	int y = niveau.plateau_y-MOTIF_HEIGHT;
	int lig, col, pos_y;
	
	while(y < niveau.plateau_y)
	{
		for(lig=0;lig<niveau.nbr_lig;lig++)
		{
			for(col=0;col<niveau.nbr_col;col++)
			{
				pos_y = get_position_y_case(lig,col);
			
				/*// si la position en y de la case n'est pas a sa position final
				if(pos_y < (niveau.plateau_y+(lig*MOTIF_HEIGHT)))
				{
					// on la descend de 1 pixel
					set_position_y_case(lig,col,pos_y+1);
				}*/
				
				// on la descend de 1 pixel
				set_position_y_case(lig,col,pos_y+1);
			}
		}
	
		dessine_fond();
		dessine_plateau(0, true);
		dessine_infos();
		
		GRRLIB_Render();
		VIDEO_WaitVSync();
		
		y++;
	}
}

void animation_inverse(int lig, int col, int lig1, int col1)
{
	int sens = 1, diff = 0;
	int x,y,x1,y1;
	
	// on garde les anciennes positions
	x = get_position_x_case(lig,col);
	y = get_position_y_case(lig,col);
	x1 = get_position_x_case(lig1,col1);
	y1 = get_position_y_case(lig1,col1);
	
	// si on deplace deux motifs verticalement
	if(lig != lig1)
	{
		// nombre de pixels de difference entre les deux lignes
		diff = get_position_y_case(lig,col)-get_position_y_case(lig1,col1);
		
		sens = lig-lig1;
	}
	// sinon on les deplace horizontalement
	else
	{
		// nombre de pixels de difference entre les deux colonnes
		diff = get_position_x_case(lig,col)-get_position_x_case(lig1,col1);
		
		sens = col-col1;
	}
	
	// multiplie le sens pas deux pour que l'animation aille plus vite
	sens *= 2;
	
	// valeur absolue de la difference /2 (divise par deux vu qu'on a multiplier par deux le sens)
	diff = abs(diff)/2;

	while(diff > 0)
	{
		// si on deplace deux motifs verticalement
		if(lig != lig1)
		{
			set_position_y_case(lig,col,get_position_y_case(lig,col)-sens);
			set_position_y_case(lig1,col1,get_position_y_case(lig1,col1)+sens);
		}
		// sinon on les deplace horizontalement
		else
		{
			set_position_x_case(lig,col,get_position_x_case(lig,col)-sens);
			set_position_x_case(lig1,col1,get_position_x_case(lig1,col1)+sens);
		}
		
		dessine_fond();
		dessine_plateau(-1, TRUE);
		dessine_infos();
		
		GRRLIB_Render();
		VIDEO_WaitVSync();
	
		diff--;
	}
	
	// on remet les anciennes positions
	set_position_x_case(lig,col,x);
	set_position_y_case(lig,col,y);
	set_position_x_case(lig1,col1,x1);
	set_position_y_case(lig1,col1,y1);
}

void animation_check_plateau(int temps_ms)
{
	int img_check = 1;
	int ti = (temps_ms/5)*1000;
	
	while(img_check < 5)
	{
		dessine_fond();
		dessine_plateau(img_check, TRUE);
		dessine_infos();
		
		GRRLIB_Render();
		VIDEO_WaitVSync();
		
		// on attend
		usleep(ti);
		
		// on passe a l'image suivante
		img_check++;
	}
	
	dessine_fond();
	dessine_plateau(0, true);
	dessine_infos();
	
	GRRLIB_Render();
	VIDEO_WaitVSync();
	
	// on attend
	usleep(ti);
}

void animation_bonus()
{
	int bonus = 0;
	
	// tant qu'on a pas atteint le temps imparti du niveau
	while(gamer.temps < niveau.temps)
	{
		// 10 point de plus par seconde
		bonus += 10;
		
		dessine_fond();
		dessine_plateau(0, TRUE);
		dessine_infos();
		dessine_bonus(bonus);
		
		GRRLIB_Render();
		VIDEO_WaitVSync();
		
		// on augmente le temps d'une seconde
		gamer.temps++;
	}
	
	dessine_fond();
	dessine_plateau(0, TRUE);
	dessine_infos();
	
	GRRLIB_Render();
	VIDEO_WaitVSync();
	
	usleep(100000);
}

/***************** BOUTONS ***************************/

void deplace_gamer()
{
	// si le joueur appui sur le bouton gauche
	if((PAD_ButtonsDown(0) & PAD_BUTTON_LEFT))
	{
		// si la case sur laquelle il se trouve est selectionne
		if(gamer.select == TRUE)
		{
			// on inverse avec celle de gauche si il a le droit
			inverse_si_ok(gamer.lig,gamer.col,gamer.lig,gamer.col-1);
		}
		// sinon si il peut aller a gauche
		else if(get_motif(gamer.lig,gamer.col-1) != niveau.hors_limite)
		{
			gamer.col--;
		}
	}
	// sinon si le joueur appui sur le bouton droit
	else if((PAD_ButtonsDown(0) & PAD_BUTTON_RIGHT))
	{
		// si la case sur laquelle il se trouve est selectionne
		if(gamer.select == TRUE)
		{
			// on inverse avec celle de droite si il a le droit
			inverse_si_ok(gamer.lig,gamer.col,gamer.lig,gamer.col+1);
		}
		// sinon il peut aller a droite
		else if(get_motif(gamer.lig,gamer.col+1) != niveau.hors_limite)
		{
			gamer.col++;
		}
	}
	// sinon si le joueur appui sur le bouton haut
	else if((PAD_ButtonsDown(0) & PAD_BUTTON_UP))
	{
		// si la case sur laquelle il se trouve est selectionne
		if(gamer.select == TRUE)
		{
			// on inverse avec celle du haut si il a le droit
			inverse_si_ok(gamer.lig,gamer.col,gamer.lig-1,gamer.col);
		}
		// sinon si il peut aller en haut
		else if(get_motif(gamer.lig-1,gamer.col) != niveau.hors_limite)
		{
			gamer.lig--;
		}
	}
	// sinon si le joueur appui sur le bouton bas
	else if((PAD_ButtonsDown(0) & PAD_BUTTON_DOWN))
	{
		// si la case sur laquelle il se trouve est selectionne
		if(gamer.select == TRUE)
		{
			// on inverse avec celle du bas si il a le droit
			inverse_si_ok(gamer.lig,gamer.col,gamer.lig+1,gamer.col);
		}
		// sinon si il peut aller en bas
		else if(get_motif(gamer.lig+1,gamer.col) != niveau.hors_limite)
		{
			gamer.lig++;
		}
	}
	// sinon si le joueur appuie sur le bouton A
	else if(PAD_ButtonsDown(0) & PAD_BUTTON_A)
	{
		// si la case sur laquelle il se trouve est selectionne
		if(gamer.select == TRUE)
		{
			// on la deselectionne
			gamer.select = FALSE;
		}
		// sinon
		else
		{
			// on la selectionne
			gamer.select = TRUE;
		}
	}
}

// retourne true pour rejouer
char jouer_plateau()
{
	int bonus;
	char quitter = FALSE;
	
	time(&start_game);
	
	// initialisation du jeu
	init_game();
	
	// anime les motifs du plateau
	animation_plateau();
	
	// pret
	dessine_fond();
	dessine_plateau(0,FALSE);
	dessine_infos();
	dessine_pret();
	GRRLIB_Render();
	VIDEO_WaitVSync();
		
	// on attend 1 seconde
	usleep(1000000);
	
	// ok!
	dessine_fond();
	dessine_plateau(0,FALSE);
	dessine_infos();
	dessine_ok();
	GRRLIB_Render();
	VIDEO_WaitVSync();
		
	// on attend 1 seconde
	usleep(1000000);
	
	// recupere le temps au lancement du plateau
	time(&start_game);

	// tant que le joueur n'a pas termin le plateau
	while(gamer.termine == FALSE)
	{
		PAD_ScanPads();
		
		// gestion des touches
		deplace_gamer();

		// dessine le fond
		dessine_fond();
		// dessine les images sur le plateau (diamant, tete, etc..)
		dessine_plateau(0, FALSE);
		// dessine le score, le temps, etc...
		dessine_infos();
		
		GRRLIB_Render();
		VIDEO_WaitVSync();
		
		// si le joueur joue depuis trop longtemps
		if(gamer.temps > niveau.temps)
		{
			gamer.termine = TRUE;
		}
	}

	gamer.gagne = is_all_valide();
	
	if(gamer.gagne == TRUE)
	{
		// 10 points par seconde
		bonus = (niveau.temps-gamer.temps)*10;
		
		// affichage de "Termin!"
		dessine_fond();
		dessine_plateau(0, TRUE);
		dessine_infos();
		dessine_termine();
		
		GRRLIB_Render();
		VIDEO_WaitVSync();
		
		// attend 500 ms
		usleep(500000);
		
		animation_bonus();
		
		// ajout du bonus au score du joueur
		gamer.score += bonus;
		
		// si il y reste au moins un plateau a jouer
		if((niveau.num+1) <= nbr_plateau)
		{
			// on n'affiche pas le menu 
			quitter = TRUE;
			gamer.rejouer = TRUE;
		}
	}
	
	// affichage du menu de fin
	while(quitter == FALSE)
	{
		PAD_ScanPads();
		
		// dessine le fond
		dessine_fond();
		
		// dessine les images sur le plateau (diamant, tete, etc..)
		dessine_plateau(0, TRUE);
		
		// affiche les infos du joueur
		dessine_infos();
		
		dessine_menu_fin();
		
		if(gamer.gagne == FALSE)
		{
			// affichage de "C'est Fini!"
			dessine_cest_fini();
		}
		
		// si le bouton A a t press
		if (PAD_ButtonsDown (0) & PAD_BUTTON_A)
		{
			quitter = TRUE;
		}
		// sinon si le bouton Haut ou Bas a t press
		else if ((PAD_ButtonsDown (0) & PAD_BUTTON_UP) || (PAD_ButtonsDown (0) & PAD_BUTTON_DOWN))
		{
			if(gamer.rejouer == TRUE)
			{
				gamer.rejouer = FALSE;
			}
			else
			{
				gamer.rejouer = TRUE;
			}
		}
		
		GRRLIB_Render();
		VIDEO_WaitVSync();
	}
	
	// si le joueur a perdu
	if(gamer.gagne == FALSE)
	{
		// on lui retire une vie
		gamer.vie--;
	}
	
	return gamer.rejouer;
}

int main()
{
	int plateau_n = 1;
	int anc_score = 0;
	
	/*---------------- INITIALISATION VIDEO ----------------*/
	GRRLIB_buffer = (u16 *)malloc(640*480*2);
	
	VIDEO_Init();
	PAD_Init();

	GRRLIB_InitVideo();
	GRRLIB_Start();
	GRRLIB_FillScreen(0x0000);		
	GRRLIB_Render();
	VIDEO_WaitVSync();

	/*-------------- FIN INITIALISATION VIDEO -----------*/
		
	// NBR_VIE vie au debut du jeu
	gamer.vie = NBR_VIE;
	
	// score au debut du jeu
	gamer.score = 0;
	anc_score = 0;
	
	// compte le nombre de plateau
	nbr_plateau_exist();
		
	if(nbr_plateau > 0)
	{
		// si le chargement du plateau c'est bien passer
		if(charger_plateau(plateau_n) == TRUE)
		{
			// tant que le joueur veut rejouer
			while(jouer_plateau() == TRUE)
			{
				// si le joueur n'a plus de vie, il a donc perdu
				if(gamer.vie < 0)
				{
					// on lui remet NBR_VIE
					gamer.vie = NBR_VIE;
					
					gamer.score = 0;
					
					plateau_n = 1;
					
					// il recommence au premier niveau
					charger_plateau(plateau_n);
				}
				// sinon si le joueur a gagne
				else if(gamer.gagne == TRUE)
				{
					anc_score = gamer.score;
					
					//si il n'y a plus de plateau
					if((plateau_n+1) > nbr_plateau)
					{
						// on charge le meme plateau
						charger_plateau(plateau_n);
					}
					// sinon
					else
					{
						// on charge le plateau suivant
						plateau_n++;
						charger_plateau(plateau_n);
					}
				}
				// sinon le joueur a perdu
				else
				{
					// il reprend le score qu'il avait au niveau precedent
					gamer.score = anc_score;
					
					// on charge le meme plateau
					charger_plateau(plateau_n);
				}
			}
		}
	}
	
	reload();
	
	return 0;
}
